command abot {
	reload {
		help Reloads answers from the .json file.;
		run abot_reload;
		perm utils.abot.reload;
	}
	list [flag:-nh] {
		help Lists all the answers. Use -nh to move info from hover to chat, recommended for Console;
		run abot_list_nh -nh;
		perm utils.abot.list;
	}
	list {
		help Lists all the answers. Use -nh to move info from hover to chat, recommended for Console;
		run abot_list -nh;
		perm utils.abot.list;
	}
	get [string:name] {
		help Gets the properties of an answer.;
		run abot_get name;
		perm utils.abot.get;
	}
	add [string:name] {
		help Adds an answer to the bot.;
		run abot_add name;
		perm utils.abot.add;
	}
	remove [string:name] {
		help Removes an answer to the bot.;
		run abot_remove name;
		perm utils.abot.remove;
	}
	edit [string:name] name [string:new] {
		help Changes the name of an answer.;
		run abot_edit_name name new;
		perm utils.abot.edit.name;
	}
	edit [string:name] message [string:new...] {
		help Changes the message of an answer.;
		run abot_edit_message name new;
		perm utils.abot.edit.name;
	}
	edit [string:name] permission [string:new] {
		help Changes the permission of an answer.;
		run abot_edit_permission name new;
		perm utils.abot.edit.permission;
	}
	edit [string:name] regex add [string:regex...] {
		help Adds a regex from an answer;
		run abot_edit_regex_add name regex;
		perm utils.abot.edit.regex;
	}
	edit [string:name] regex remove [string:regex...] {
		help Removed a regex from an answer;
		run abot_edit_regex_remove name regex;
		perm utils.abot.edit.regex;
	}
}